% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/endpoints.R
\name{pub_covidcast_meta}
\alias{pub_covidcast_meta}
\title{Metadata for the COVIDcast endpoint}
\usage{
pub_covidcast_meta(fetch_args = fetch_args_list())
}
\arguments{
\item{fetch_args}{\code{\link{fetch_args}}. Additional arguments to pass to \code{fetch()}.}
}
\value{
\code{\link[tibble:tibble]{tibble::tibble}}
}
\description{
API docs:
\url{https://cmu-delphi.github.io/delphi-epidata/api/covidcast_meta.html}.

Fetch a summary of metadata for all sources and signals that are available in
the API, along with basic summary statistics such as the dates they are
available, the geographic levels at which they are reported, and etc.
}
\examples{
\dontrun{
pub_covidcast_meta()
}

}
\seealso{
\code{\link[=pub_covidcast]{pub_covidcast()}},\code{\link[=covidcast_epidata]{covidcast_epidata()}}
}
\keyword{endpoint}
