% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/endpoints.R
\name{pub_dengue_nowcast}
\alias{pub_dengue_nowcast}
\title{Delphi's PAHO dengue nowcasts (North and South America)}
\usage{
pub_dengue_nowcast(locations, epiweeks = "*", fetch_args = fetch_args_list())
}
\arguments{
\item{locations}{character. Locations to fetch.}

\item{epiweeks}{\code{\link{timeset}}. Epiweeks to fetch. Defaults to all ("*") dates.}

\item{fetch_args}{\code{\link{fetch_args}}. Additional arguments to pass to \code{fetch()}.}
}
\value{
\code{\link[tibble:tibble]{tibble::tibble}}
}
\description{
API docs: \url{https://cmu-delphi.github.io/delphi-epidata/api/dengue_nowcast.html}
}
\examples{
\dontrun{
pub_dengue_nowcast(
  locations = "pr",
  epiweeks = epirange(201401, 202301)
)
}
}
\keyword{endpoint}
